fnom_odb='Biax_36.odb'
fnom_COORD='res-COORD_Biax_36.tmt'
fnom_RF='res-RF_Biax_36.tmt'
fsignal_fin_coord_disp='fin_disp.tmp'


import os,sys
from odbAccess import *

#-----------------------------------------#
# ## DATA ##
# opening of the odb file
myodb=openOdb(fnom_odb)
myFRAME=myodb.steps['Loading'].frames
#n_SET1=myodb.rootAssembly.instances['SPECIMEN-1'].nodeSets['RP1']
n_SET1=myodb.rootAssembly.nodeSets['RP1']
#n_SET2=myodb.rootAssembly.instances['SPECIMEN-1'].nodeSets['RP2']
n_SET2=myodb.rootAssembly.nodeSets['RP2']
#n_SET3=myodb.rootAssembly.instances['SPECIMEN-1'].nodeSets['RP3']
n_SET3=myodb.rootAssembly.nodeSets['RP3']
#n_SET4=myodb.rootAssembly.instances['SPECIMEN-1'].nodeSets['RP4']
n_SET4=myodb.rootAssembly.nodeSets['RP4']
#n_SET5=myodb.rootAssembly.instances['SPECIMEN-1'].nodeSets['LOAD_X']
n_SET5=myodb.rootAssembly.nodeSets['LOAD_X']
#n_SET6=myodb.rootAssembly.instances['SPECIMEN-1'].nodeSets['LOAD_Y']
n_SET6=myodb.rootAssembly.nodeSets['LOAD_Y']
#timepoints=(0,0.2,0.4,0.6,0.8,1)

#%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
#			Coordinates o/p
#%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
#Writing X Coordinates of markers
coordFile = open(fnom_COORD,'w')
coordFile.write('RP1\tRP2\tRP3\tRP4\n')
for F in myFRAME:
	v=F.fieldOutputs['COORD'].getSubset(region=n_SET1).values
	for s in v:
		coordFile.write('%f\t' %(s.data[0]))
	v=F.fieldOutputs['COORD'].getSubset(region=n_SET2).values
	for s in v:
		coordFile.write('%f\t' %(s.data[0]))
	v=F.fieldOutputs['COORD'].getSubset(region=n_SET3).values
	for s in v:
		coordFile.write('%f\t' %(s.data[0]))
	v=F.fieldOutputs['COORD'].getSubset(region=n_SET4).values
	for s in v:
		coordFile.write('%f\t' %(s.data[0]))
	coordFile.write('\n')


#Writing Y Coordinates of markers
for F in myFRAME:
	v=F.fieldOutputs['COORD'].getSubset(region=n_SET1).values
	for s in v:
		coordFile.write('%f\t' %(s.data[1]))
	v=F.fieldOutputs['COORD'].getSubset(region=n_SET2).values
	for s in v:
		coordFile.write('%f\t' %(s.data[1]))
	v=F.fieldOutputs['COORD'].getSubset(region=n_SET3).values
	for s in v:
		coordFile.write('%f\t' %(s.data[1]))
	v=F.fieldOutputs['COORD'].getSubset(region=n_SET4).values
	for s in v:
		coordFile.write('%f\t' %(s.data[1]))
	coordFile.write('\n')
coordFile.close()

#%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
#			Reaction Forces o/p
#%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

#Writing RF of X-hooks
rfFile = open(fnom_RF,'w')
rfFile.write('hook_A\thook_B\t\n')
for F in myFRAME:
	v=F.fieldOutputs['RF'].getSubset(region=n_SET5).values
	for s in v:
		rfFile.write('%f\t' %(s.data[0]))
	rfFile.write('\n')

#Writing RF of Y-hooks
for F in myFRAME:
	v=F.fieldOutputs['RF'].getSubset(region=n_SET6).values
	for s in v:
		rfFile.write('%f\t' %(s.data[1]))
	rfFile.write('\n')
rfFile.close()


#-----------------------------------------#
# closing of the odb file
myodb.close()


# writing end signal
fdone = open(fsignal_fin_coord_disp, 'w')
fdone.close()