// In this version of GA code, Penalty function has been reformulated so that:
//1- Parameters that does not satosfy
function [residue]=cost_function_ga_rev01(x)
//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
// Function that evaluates the residue vector (Yexp-Ynum) for a given set of parameters x for 3D
//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
// x = param
//ind = the integer flag: ind=2 (3 or 4)-> costf must provide f (resp. g, f and g) ; ind=1 nothing is computed (used for display purposes only). if optim
//ind=m= number of function, if lsqrsolve
//residue = objective value
//g = gradient


t01=tic();

global counter
global pop_size

global job_name
global run_folder
cd (run_folder) ;

Ti=clock();
fid1=mopen('logout.txt','a');
mfprintf(fid1,"\n ------------------------------- \n");
mfprintf(fid1,'Call of the cost function at %u h %u min.\n',Ti(4),Ti(5));
mclose(fid1);
xreal=x;
for i=1:9 
    xreal(i)=xreal(i)*100;
end
//Asses .1: Evaluate constraint violation
const1 =(((xreal(1)*xreal(3))-(xreal(2)^2))*xreal(6))-(xreal(1)*(xreal(5)^2))+(2*xreal(2)*xreal(5)*xreal(4))-(xreal(3)*(xreal(4)^2));// constraint 1: const1>0

const2 =xreal(1)*xreal(3);// constraint 2: const2>sqr(b1122)

if const1<0 & const2<(xreal(2)^2) then 
    residue = 50;
    fid1=mopen('logout.txt','a');
    mfprintf(fid1,">>>Constraints 1&2 violation!!\n const1= %f \n const2= %f > %f \n residue=50 \n", const1,const2,xreal(2)^2);
    mclose(fid1);
    
    fid=mopen('costf.txt','a');
    mfprintf(fid,"%f \t %f %f %f %f %f %f %f %f %f %f \n",residue, xreal');
    mclose(fid);
    
elseif const2<(xreal(2)^2) then 
    residue = 1;
    fid1=mopen('logout.txt','a');
    mfprintf(fid1,">>>Constraint 2 violation!!\n const1= %f \n const2= %f > %f \n residue=1 \n", const1,const2,xreal(2)^2);
    mclose(fid1);
    
    fid=mopen('costf.txt','a');
    mfprintf(fid,"%f \t %f %f %f %f %f %f %f %f %f %f \n",residue, xreal');
    mclose(fid);
    
elseif const1<0
    residue = 0.5;
    fid1=mopen('logout.txt','a');
    mfprintf(fid1,">>>Constraint 1 violation!!\n const1= %f \n const2= %f > %f \n residue=0.5 \n", const1,const2,xreal(2)^2);
    mclose(fid1);
    
    fid=mopen('costf.txt','a');
    mfprintf(fid,"%f \t %f %f %f %f %f %f %f %f %f %f \n",residue, xreal');
    mclose(fid);
else
    x_file2(xreal);
    fid1=mopen('logout.txt','a');
    mfprintf(fid1,'Abaqus computation start. \n'); mclose(fid1);
    xpause(1*1000000);
    for index=1:3
        dos(strcat(["abaqus job=",job_name(index).entries," user=fiberdirection_rev06_28dinf.for"]));//run the job
        fid1=mopen('logout.txt','a');
        mfprintf(fid1,"Job ("+job_name(index).entries+") is submitted for analysis.\n"); mclose(fid1);
        xpause(10*1000000);
        while isfile(strcat([job_name(index).entries,".lck"]))
        xpause(1*1000000);
        end;
        // displacement/reaction force writing (Python)
        dos(strcat(["abaqus python Script_writing_main_",job_name(index).entries,".py"]));
        while ~isfile('fin_disp.tmp')
        xpause(1*1000000);
        end;
        fid1=mopen('logout.txt','a');
        mfprintf(fid1,"Coord and RF have been written for Job ("+job_name(index).entries+").\n"); mclose(fid1);
        mdelete("fin_disp.tmp");
    end
    res = calc_res4();
    if isnan(res) then // This line is to prevent Nan's from being residuals.
        residue=51;
        else residue=res/100;
    end
    fid1=mopen('logout.txt','a');
    mfprintf(fid1,"Residue calculation is complete. Residue = %f \n", residue);
    mclose(fid1);
    
    fid=mopen('costf.txt','a');
    mfprintf(fid,"%f \t %f %f %f %f %f %f %f %f %f %f \n",residue, xreal');
    mclose(fid);
    
    clean_dir('abq_res');
    
    t0=toc();
    h0=floor(t0/3600);
    m0=floor((t0-h0*3600)/60);
    s0=round(t0-m0*60-h0*3600);
    
    fid1=mopen('logout.txt','a');
    mfprintf(fid1,':-) Duration of the Abaqus computation: %u h, %u min et %u sec ! c= %1.5f \n',h0,m0,s0,xreal(10));

    mclose("all")
end


endfunction

//======= Counting population =====
counter=counter-1;
if counter==0 then
    fid=mopen('costf.txt','a');
    mfprintf(fid,"========================== NEW GENERATION ==========================\n");
    mclose(fid);
    counter=pop_size;
end

//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
// Function that moves results into the result folder and deletes unnecessary
//files from the working directory

function clean_dir(folder)

global job_name
global run_folder
cd (run_folder);

mkdir(folder);

for index=1:3
try
    movefile(strcat(["res-COORD_",job_name(index).entries,".tmt"]),folder);
    movefile(strcat(["res-RF_",job_name(index).entries,".tmt"]),folder);
end
copyfile(strcat([job_name(index).entries,".inp"]),strcat([job_name(index).entries,"2.inp"]));
movefile(strcat([job_name(index).entries,".odb"]),folder);
mdelete(strcat([job_name(index).entries,".*"]));
copyfile(strcat([job_name(index).entries,"2.inp"]),strcat([job_name(index).entries,".inp"]));
end
mdelete('abaqus.*');
mdelete('*.tmt');

endfunction



