function [Sx,Sxx,Sy,Syy]=get_result(Gname)

//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
//Getting Experimental data
//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

fd=mopen(strcat(["28d_inf_",Gname,"_intrp.dat"]), 'r');
mfscanf(fd,'%s %s %s %s %s %s');
expdata= mfscanf(-1,fd,'%f %f %f %f %f %f');
mclose(fd);
Ex=expdata(:,1);
Sx=expdata(:,2); 
Ey=expdata(:,3);
Sy=expdata(:,4);


//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
//Getting Simu data
//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

// Coord file and calculate Strain vectors
//---------------------------------------
fd=mopen(strcat(["res-COORD_",Gname,".tmt"]), 'r');
mfscanf(fd,'%s %s %s %s');
coord= mfscanf(-1,fd,'%f %f %f %f');
mclose(fd);
half=size(coord,1)/2;
[Ex$,Ey$]=str(coord(1:half,1),coord(1:half,2),coord(1:half,3),coord(1:half,4),coord((half+1):$,1),coord((half+1):$,2),coord((half+1):$,3),coord((half+1):$,4));

// RF file and calculate Stress vectors
//---------------------------------------
fd=mopen(strcat(["res-RF_",Gname,".tmt"]), 'r');
mfscanf(fd,'%s %s');//8 columns of data --> this number should be adjusted in case of mesh refinement.
rf= mfscanf(-1,fd,'%f %f %f %f');//8 columns of data --> this number should be adjusted in case of mesh refinement.
mclose(fd);
rf1=rf;
rf1(:,[3,4])=[];
RF=sum(rf1,2)

Sx$=RF(1:half).*57262;
Sy$=RF((half+1):$).*57262;
//============================================================
//===================%%%% NOTE %%%%===========================
//how 57262 were calculated?
//S=F[N]/A[m^2]=F/L*T/1000,000=F/11.76*1.485/1000,000=F*57262
//so .. S=F*57262 >> for 28d-infarct models
//============================================================

// Interpolate Simu data:
//--------------------------

Sxx=interp1(Ex$,Sx$,Ex,"nearest");
Syy=interp1(Ey$,Sy$,Ey,"nearest");

sim=mopen('simulated_stress_result.dat', 'a')
mfprintf(fd, '\nSxx \t Syy \n');
mfprintf(sim,'%f \t %f \n',Sxx,Syy);
mclose(sim);

//figure()
//plot(Ex,Sx,'r-o',Ex,Sxx,'b-X')
//xtitle('Circumferential', 'Strain', 'Stress (Pa)');
//legend('Exp','Simu',[-5], %F);
////xsave('interpolated data_F.scg')
//
//figure()
//plot(Ey,Sy,'r-o',Ey,Syy,'b-X')
//xtitle('Longitudinal', 'Strain', 'Stress (Pa)');
//legend('Exp','Simu',[-5], %F);
//xsave('interpolated data_F.scg')

endfunction
